function [RES,scales]=dynamicLZWn(X,patternLength,similarityCoefficient,beginScale,endScale,typeOfEntropy,beginWidth,stepWidth,TypeReturns);

% X повинен бути вектор-стовпчиком
[m,n]=size(X);
if (m<n) X=X'; end
% повинен бути лише один стовпчик
X=X(:,1); [m,n]=size(X);

startIndex=1;
endIndex=startIndex+beginWidth-1;
if (TypeReturns==1)
    n=length(X);
    X=(X(2:n)-X(1:n-1))./X(2:n);
    X=X/std(X);
end

while endIndex<=m-1
    Y=X(startIndex:endIndex,:);
    MSE=MSE2n(Y,patternLength,similarityCoefficient,beginScale,endScale,typeOfEntropy);
    RESt=MSE(2,:); RESt=RESt';
    if startIndex==1
        RES=RESt;
        scales=MSE(1,:);
        scales=scales';
    else
        RES=[RES RESt];
    end
    startIndex=startIndex+stepWidth;
    endIndex=endIndex+stepWidth;
end

    